function  sampleData3d03()
fprintf('\n--------------- sampleData3d03\n')
close all
trans=@(q)  [2*q(1,:);q(2,:);0.5*q(3,:).*(1+0.5*sin(2*pi*q(1,:)))];
meshfile=gmsh.buildmesh3d('ball8',20);
Th=siMesh(meshfile,'trans',trans);
fprintf('Mesh : nq=%d, nme=%d, h=%.3f\n',Th.nq,Th.get_nme(),Th.get_h())

tstart=tic();
figure(1)
axis off;axis image
Th.plotmesh('d',2,'legend',true);
T=toc(tstart);
title(sprintf('nq=%d, nme=%d, display in %.3f(s)',Th.nq,Th.get_nme(),T))

u=@(x,y,z) cos(2*x-y-z).*sin(x-2*y+z);
U=Th.eval(u);

tstart=tic();
figure(2)
P=fc_tools.graphics.PlaneCoefs([0 0 0],[0 1 1]);
Th.slice(U,P)
hold on
Th.plot(U,'d',2,'labels',[1,2],'EdgeColor','None')
caxis([min(U),max(U)])
isorange=linspace(min(U),max(U),15);
Th.plotmesh('d',2,'labels',[3,4],'FaceColor','none', 'EdgeColor',0.95*[1,1,1])
Th.plotiso(U,'labels',[3,4],'isorange',isorange,'color','w')
Th.sliceiso(U,P,'isorange',isorange,'color','w')
shading interp
%Th.plotmesh('d',2,'labels',[10,20,21], 'legend',false, 'PlotOptions',{'FaceAlpha',0.1,'FaceColor','none', 'EdgeColor',0.95*[1,1,1]})
view(127,-1)
axis off;axis image;
T=toc(tstart);
title(sprintf('nq=%d, nme=%d, display in %.3f(s)',Th.nq,Th.get_nme(),T))

tstart=tic();
figure(3)
P1=fc_tools.graphics.PlaneCoefs([0 0 0],[1 0 0]);
Th.slice(U,P1,'FaceColor','interp')
hold on
Th.sliceiso(U,P1,'isorange',isorange,'color','w')
P2=fc_tools.graphics.PlaneCoefs([0 0 0],[0 1 0]);
Th.slice(U,P2,'FaceColor','interp')
Th.sliceiso(U,P2,'isorange',isorange,'color','w')
P3=fc_tools.graphics.PlaneCoefs([0 0 0],[0 0 1]);
Th.slice(U,P3,'FaceColor','interp')
Th.sliceiso(U,P3,'isorange',isorange,'color','w')
P4=fc_tools.graphics.PlaneCoefs([-1 0 0],[1 0 0]);
Th.slice(U,P4,'FaceColor','interp')
Th.sliceiso(U,P4,'isorange',isorange,'color','w')
P5=fc_tools.graphics.PlaneCoefs([1 0 0],[1 0 0]);
Th.slice(U,P5,'FaceColor','interp')
Th.sliceiso(U,P5,'isorange',isorange,'color','w')
view(-52,20)
Th.plotmesh('d',1,'color','k','Linewidth',1.5)
axis off;axis image;
T=toc(tstart);
title(sprintf('nq=%d, nme=%d, display in %.3f(s)',Th.nq,Th.get_nme(),T))

tstart=tic();
figure(4)
P1=fc_tools.graphics.PlaneCoefs([0 0 0],[1 0 0]);
Th.slicemesh(P1,'FaceColor',0.9*[1 1 1],'EdgeColor','none')
hold on
Th.sliceiso(U,P1,'isorange',isorange)
P2=fc_tools.graphics.PlaneCoefs([0 0 0],[0 1 0]);
Th.slicemesh(P2,'FaceColor',0.9*[1 1 1],'EdgeColor','none')
Th.sliceiso(U,P2,'isorange',isorange)
P3=fc_tools.graphics.PlaneCoefs([0 0 0],[0 0 1]);
Th.slice(U,P3,'FaceColor','interp')
Th.sliceiso(U,P3,'isorange',isorange,'color','w')
P4=fc_tools.graphics.PlaneCoefs([-1 0 0],[1 0 0]);
Th.slice(U,P4,'FaceColor','interp')
Th.sliceiso(U,P4,'isorange',isorange,'color','w')
P5=fc_tools.graphics.PlaneCoefs([1 0 0],[1 0 0]);
Th.slice(U,P5,'FaceColor','interp')
Th.sliceiso(U,P5,'isorange',isorange,'color','w')
Th.plotmesh('d',1,'legend',false,'color','k','Linewidth',1.5)
view(-52,20)
axis off;axis image;
T=toc(tstart);
title(sprintf('nq=%d, nme=%d, display in %.3f(s)',Th.nq,Th.get_nme(),T))

fc_tools.graphics.DisplayFigures();
